const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const classes = sequelize.define(
    'classes',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

code: {
        type: DataTypes.TEXT,
      
      

      },

capacity: {
        type: DataTypes.INTEGER,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"planned",


"active",


"completed",


"archived"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  classes.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

















    db.classes.hasMany(db.class_enrollments, {
      as: 'class_enrollments_class',
      foreignKey: {
          name: 'classId',
      },
      constraints: false,
    });


    db.classes.hasMany(db.course_sections, {
      as: 'course_sections_class',
      foreignKey: {
          name: 'classId',
      },
      constraints: false,
    });














//end loop



    db.classes.belongsTo(db.schools, {
      as: 'school',
      foreignKey: {
        name: 'schoolId',
      },
      constraints: false,
    });

    db.classes.belongsTo(db.campuses, {
      as: 'campus',
      foreignKey: {
        name: 'campusId',
      },
      constraints: false,
    });

    db.classes.belongsTo(db.academic_years, {
      as: 'academic_year',
      foreignKey: {
        name: 'academic_yearId',
      },
      constraints: false,
    });

    db.classes.belongsTo(db.grade_levels, {
      as: 'grade_level',
      foreignKey: {
        name: 'grade_levelId',
      },
      constraints: false,
    });

    db.classes.belongsTo(db.teachers, {
      as: 'homeroom_teacher',
      foreignKey: {
        name: 'homeroom_teacherId',
      },
      constraints: false,
    });




    db.classes.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.classes.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return classes;
};


